<?php

namespace App\Database\Migrations;

use CodeIgniter\Database\Migration;
use CodeIgniter\Database\RawSql;

class ChatNotifications extends Migration
{
    protected array $COLUMNS = [
        "id" => [
            "type" => "INT",
            "unsigned" => true,
            "auto_increment" => true
        ],
        "chat_message_id" => [
            "type" => "INT",
        ],
        "user_id" => [
            "type" => "INT",
            "unsigned" => true,
        ],
        "viewed" => [
            "type" => "BOOLEAN",
            "default" => false
        ],
    ];
    public function up()
    {
        $this->forge->addField($this->COLUMNS);
        $currenttime = new RawSql("CURRENT_TIMESTAMP");
        $this->forge->addField([
            "created_at" => [
                "type" => "TIMESTAMP",
                "default" => $currenttime,
            ],
            "updated_at" => [
                "type" => "TIMESTAMP",
                "null" => true,

            ],
            "deleted_at" => [
                "type" => "TIMESTAMP",
                "null" => true,

            ],
        ]);
        $this->forge->addPrimaryKey('id');
        $this->forge->addForeignKey(["chat_message_id"], "chat_messages", ["id"]);
        $this->forge->addForeignKey(["user_id"], "users", ["id"]);
        $this->forge->createTable("chat_notifications", true);
    }

    public function down()
    {
        $this->forge->dropTable("chat_notifications");
    }
}
